/*------------------------------------------------------------------------*/
/*   rudimentale filtro di stampa per hp laserjetII                       */
/*   steffe marzo 1991   Dipartimento di Matematica Pisa 	          */
/*   Il programma cerca di capire dai primi 512 caratteri	          */
/*   se il file e' plain ascii o meno; nel primo caso formatta            */
/*   grezzamente le pagine  con 76 caratteri per riga e 64 righe          */
/*   nel secondo caso manda i caratteri alla stampante raw                */
/*------------------------------------------------------------------------*/
/*   steffe luglio 1991 aggiunto controllo se i primi due caratteri       */
/*   sono %! e in tal caso rifiuto di stampare il file postscript e       */
/*   stampa invece " I file PostScript non si possono stampare sulla HP " */
/*------------------------------------------------------------------------*/

#include <stdio.h>

#define CR (int)13     	 /* carriage return */
#define LF (int)10  	 /* line feed */
#define FF (int)14  	 /* form feed */
#define SPACE (int)32    /* blank space */
#define TAB (int)9  	 /* tab	vale 8 spazi  */
#define ESC (int)27  	 /* escape */
#define PERCENTO (int)37        /* %   */
#define ESCLAMATIVO (int)33     /* !   */

#define RESET "\033E"	 /* reset stampante  */

/* variabili globali                                                      */

int 	k,status,ibuf,buf[513],lastchar,righe,colonne;

/* k posizione sulla riga, status=0 se ASCII , 1 altrimenti (PCL)         */
/* ibuf numero caratteri  nel buffer se meno di 512 e buf[] buffer        */
/* lastchar ultimo carattere stampato, per controllo sequenze CR LF       */

/* main  -----------------------------------------------------------------*/

main()

{
	int  i,c;

/* inizializzazione della stampante	*/
	 ibuf=0; status=0;k=0; righe=76;colonne=64; 
	for(i=0;i < 16; i++) printf("%s", RESET);
/* questo reset ripetuto passa anche se la stampante era spenta !! */
	i=0;
/* lettura dei dati dal file standard input  	*/
	while ((c = getchar()) != EOF) {
		i++;
		if(i <= 512) {ibuf++;	buf[ibuf]=c; };
		if(i == 512) vuotabuffer();		
		if(i > 512) vuotachar(c);
	}
	if(ibuf < 512) vuotabuffer();
	if(status == 0) {
		putchar(FF);
		putchar(CR);
		putchar(LF);
	};
	if(status == 2) {
	putchar(CR);putchar(LF);putchar(CR);putchar(LF);putchar(CR);putchar(LF);
        printf("       Mi dispiace:");
	putchar(CR);putchar(LF);
	printf("       Non si puo' stampare files PostScript su questa HP");
        putchar(CR);putchar(LF);
	printf("       ----> Non ha il PostScript !!! <----");
	        putchar(FF);
                putchar(CR);
                putchar(LF);

        }

	printf("%s", RESET);
	return(0);
}

/*--------------------------------------------------------------------------*/
	
vuotabuffer()
{
	int i;
/*  se tra i primi caratteri si trova ESC allora non e' ascii    */
	for(i=1;i<ibuf;i++) if(buf[i] == ESC) {status=1;break;}

/*  se i primi due caratteri sono % e ! allora e' un file PostScrip */
        if( (buf[1] == PERCENTO) && (buf[2] == ESCLAMATIVO) ) status=2;

/*  stabilito che tipo di file e', vuota  il buffer              */
	for(i=1;i<=ibuf;i++)  vuotachar(buf[i]);
}
/*--------------------------------------------------------------------------*/

vuotachar(d)
int d;
{
/* se e` un file non ascii, passa i caratteri cosi` come sono    */
	if(status==1) putchar(d);

	else
/* se e` un file PostScript non fare nulla                      */
        if(status==2){}
        else
/* se e` un file ascii occorre formattare il testo               */
	{	
/* ------------    inizio formattazione        */
/* carattere normale, non CR,LF,TAB            */
	if((d!=CR)&&(d!=LF)&&(d!=TAB)) {
		if(k<=righe) k++ ; else {k=3; putchar(CR); putchar(LF);
			             putchar(SPACE); putchar(SPACE);}
		putchar(d);
		};
/* un TAB                                      */
	if(d==TAB) {
		if(k<=((righe/8)*8 - 1)) { k=((k/8)+1)*8 ; putchar(d);}
			else { k=8; putchar(CR); putchar(LF); putchar(d);};
		}
/*  un CR o LF ma il carattere precedente non era LF o CR        */
	if(((d==CR)&&(lastchar!=LF))||((d==LF)&&(lastchar!=CR)))
		{k=0; putchar(CR); putchar(LF);}
/*  nel caso rimanente, si ha una coppia CR LF o LF CF e il secondo */
/*  carattere viene ignorato                                        */	
	
	lastchar=d;
/* ------------      fine formattazione        */
	}
}
		
/*---------------------------------------------------------------------------------*/





